;
; AlxdLotsiaExtension.lsp
;
; Module to return object ID of file.
;
; Copyright 2007 Alexander Shchetinin
;
; storagepath - path of Lotsia library
; connectionstr - connection string for your database
; sqlstr - SQL query for your database
;
; Use command _appload to load application to AutoCAD.
;

(vl-load-com)

(setq storagepath "Y:\\")

(vlax-import-type-library
  :tlb-filename "C:/Program Files/Common Files/System/ado/msado15.dll"
  :methods-prefix "adom-"
  :properties-prefix "adop-"
  :constants-prefix "adoc-"
) 

;(filename2objid (strcat (getvar "DWGPREFIX") (getvar "DWGNAME")))
(defun filename2objid ( filename / objid)

  (if (= (vl-filename-directory filename) storagepath)
    (progn

      (setq
        filenamebase (vl-filename-base filename)
        fileversion (substr filenamebase (1- (strlen filenamebase)) 2)
        filenamedoc (strcat (substr filenamebase 1 (- (strlen filenamebase) 2)) (vl-filename-extension filename))
        connectionstr (vlax-make-variant "Provider=MSDASQL.1;Password=sql;Persist Security Info=True;User ID=dba;Data Source=PDM")
        sqlstr (vlax-make-variant (strcat "SELECT object_reference_id FROM LSDBO.File_V where file_name = '" filenamedoc "'"))
        recordset (vlax-create-object "ADODB.Recordset")
      )
      (adom-Open recordset sqlstr connectionstr -1 -1 -1)

      (setq fields (adop-get-Fields recordset))
      (if (eq (adop-get-EOF recordset) :vlax-false)
        (setq objid (vlax-variant-value (vlax-variant-change-type (adop-get-Value (adop-get-Item fields 0)) 8)))
      )
      (vlax-release-object fields)
      (vlax-release-object recordset)

    )
  )

  objid
)